EOL		equ NULL
CRLF		equ <13, 10, EOL>

DbgPrint proto C

%DBG macro Msg$, ArgList:VARARG
Local S$
	if OPT_DEBUG eq TRUE
		pushfd
		pushad
		Args = 1
		For Arg, <ArgList>
			Args = Args + 1
			push Arg
		Endm
	.data
		S$ CHAR Msg$, CRLF
	.code
		push offset S$
;		Call DbgPrint
		Call LgPrint
		add esp,Args * 4
		popad
		popfd
	endif
endm

RANGE struct
Base			PVOID ?
Limit		PVOID ?
RANGE ends
PRANGE typedef ptr RANGE

NTMM struct	; Alloc/Free service IDs.
Alloc	ULONG ?
Free		ULONG ?
NTMM ends
PNTMM typedef ptr NTMM

TIMING struct
File		LARGE_INTEGER <>	; Abs
Object	LARGE_INTEGER <>	; Abs
Timer	LARGE_INTEGER <>	; Rel
NtTicks	LARGE_INTEGER <>	; KI/CM
RtTicks	LARGE_INTEGER <>
Current	LARGE_INTEGER <>	; Abs
TIMING ends

PCS struct	; JMP FAR P32:S16
Sptr		PVOID ?
Ssel		ULONG ?
PCS ends

GF_NTEXT		equ 0

TURBO struct
Id		ULONG ?	; << 16
Thunk	PVOID ?	; @V:THUNK64
Return	PVOID ?
Service	PVOID ?	; @TurboDispatchJumpAddressEnd
Dispatch	PVOID ?	; @TurboThunkDispatch
TURBO ends
PTURBO typedef ptr TURBO

WOW struct
Ps		PCS <>
Turbo	TURBO <>
WOW ends

API struct
pZwAllocateVirtualMemory		PVOID ?
pZwFreeVirtualMemory		PVOID ?
pZwYieldExecution			PVOID ?
Eol						ULONG ?
API ends

TENV struct	; Temp ENV(use at init).
Flags	DWORD ?
Key		DWORD ?
Wow		WOW <>	; CM gate CS:PTR; FIRST FIELD!
NtBase	PVOID ?
Mm		NTMM <>
Api		API <>
Yield	ULONG ?	; NtYieldExecution
Section	HANDLE ?
Smap		PVOID ?
Rmap		PVOID ?
Trace	BOOL 32 DUP (?)
Time		TIMING <>
TENV ends

ENV struct	; Global envir.
		TENV <>
TsBase	PVOID ?
TsMap	DWORD 8 DUP (?)
Gid		ULONG ?	; NtUserEnumDisplayMonitors
Rid		ULONG ?	; NtCallbackReturn
Gsz		ULONG ?	; KICB args
NtTree	RTL_AVL_TABLE <>
NtStore	RANGE <>
Timer	HANDLE ?

ENV ends
PENV typedef ptr ENV

SST struct		; Stack state.
Stack	PVOID ?
Frame	PVOID ?
SST ends
PSST typedef ptr SST

TF_SCRC	equ 0	; STKCRC()

TLS struct		; Local storage in TEB.
Flags	DWORD ?
Key		DWORD ?
Crc		DWORD ?
Stack	PVOID ?
Tid		ULONG ?
TsI		ULONG ?	; TLS ID
Store	BYTE OPT_STACK_SIZE DUP (?)	
TLS ends
PTLS typedef ptr TLS

DTLS		equ PAGE_SIZE - 4	; TEB[DTLS]:PTLS
DENV		equ PAGE_SIZE - 4	; PEB[DENV]:PENV
DWOW		equ 0C0H
DKEY		equ PAGE_SIZE - 2*4
DSST		equ PAGE_SIZE - 4*4

	assume fs:nothing
%TLSP macro R
	mov R,D fs:[DTLS]
	assume R:PTLS
endm

%TLSR macro R, V
	%TLSP R
	mov R,[R].V
endm

%ENVP macro R
	mov R,fs:[TEB.Peb]
	mov R,D [R][DENV]
	assume R:PENV
endm

%ENVR macro R, V	; Read ENV.V
	%ENVP R
	mov R,[R].V
endm

%ENVS macro V
	mov eax,fs:[TEB.Peb]
	mov D [eax][DENV],V
endm

RGP struct	; PUSHAD frame.
rEdi			DWORD ?
rEsi			DWORD ?
rEbp			DWORD ?
rEsp			DWORD ?
rEbx			DWORD ?
rEdx			DWORD ?
rEcx			DWORD ?
rEax			DWORD ?
RGP ends
PRGP typedef ptr RGP