CRC_NTDLL_U	equ 26797E77H

; +
;
; o Async access to LDR!
;
	assume fs:nothing
PeGetNativeBase proc uses ebx esi edi
	mov ebx,fs:[TEB.Peb]
	mov ebx,PEB.Ldr[ebx]
	lea ebx,PEB_LDR_DATA.InMemoryOrderModuleList[ebx]	; Head
	assume ebx:PLIST_ENTRY
	
	mov esi,[ebx].Flink
	assume esi:PLIST_ENTRY
	
	.while Ebx != Esi
		lea edi,[esi][-LDR_DATA_TABLE_ENTRY.InMemoryOrderModuleList]
		assume edi:PLDR_DATA_TABLE_ENTRY
		
		movzx eax,[edi].BaseDllName._Length
		invoke Crc32, CRC32_BASE, [Edi].BaseDllName.Buffer, Eax
		.if Eax == CRC_NTDLL_U
			mov eax,[edi].DllBase
			mov edx,edi
			jmp Exit
		.endif
		mov esi,[esi].Flink
	.endw
	xor eax,eax
Exit:
	ret
PeGetNativeBase endp

; +
; ZF if success.
;
PeEnumExport proc uses ebx esi edi Image:PVOID, Callback:PVOID, Argument:PVOID
Local Export:PIMAGE_EXPORT_DIRECTORY
	mov ebx,Image
	mov eax,ebx
	add eax,IMAGE_DOS_HEADER.e_lfanew[eax]
	mov eax,IMAGE_NT_HEADERS.OptionalHeader.DataDirectory.VirtualAddress[eax]
	add eax,ebx
	assume eax:PIMAGE_EXPORT_DIRECTORY
	mov Export,eax

	mov edi,[eax].NumberOfNames
	mov esi,[eax].AddressOfNames	
	xor eax,eax
	.if Esi && Edi
		add esi,ebx
	Walk:	
		mov eax,D[esi][edi*4][-4]
		add eax,ebx
		push eax
	
		mov ecx,Export
		assume ecx:PIMAGE_EXPORT_DIRECTORY
		mov eax,[ecx].AddressOfNameOrdinals
		add eax,ebx
		movzx edx,W[2*edi][eax][-2]
		mov eax,[ecx].AddressOfFunctions
		add eax,ebx
		mov eax,D[4*edx][eax]
		add eax,ebx
		
		push eax
		push Argument
		Call Callback
		jz Exit
		dec edi
		jnz Walk
	.endif
	test ebx,ebx
Exit:
	ret
PeEnumExport endp

; +
;
PeIsApiCrc32 proc Hash:PVOID, Entry:PVOID, $Name:PSTR
	invoke Crc32S, CRC32_BASE, $Name
	cmp Hash,eax
	cmovz eax,Entry
	ret
PeIsApiCrc32 endp

; +
; ZF if success.
;
xPeQueryRoutines proc uses edi ImageBase:PVOID, pList:PVOID
	mov edi,pList
Walk:
	invoke PeEnumExport, ImageBase, offset PeIsApiCrc32, D[Edi]
	.if Zero?
		stosd
		cmp D [edi],0	; EOL
		jne Walk
	.endif
	ret
xPeQueryRoutines endp

APIS struct
N		ULONG ?
pList	PVOID ?
Map		BYTE 256 DUP (?)
APIS ends
PAPIS typedef ptr APIS

; +
;
PeIsApiCrc32Fast proc uses ebx Api:PAPIS, Entry:PVOID, $Name:PSTR
	invoke Crc32S, CRC32_BASE, $Name
	mov ebx,Api
	assume ebx:PAPIS
	xor ecx,ecx
	mov edx,[ebx].pList
	.repeat
		bt D[ebx].Map,ecx
		.if !Carry?
			.if D[Edx] == Eax
				mov eax,Entry
				bts D[ebx].Map,ecx
				mov D[edx],eax
				dec [ebx].N
			.endif
		.endif
		inc ecx
		add edx,4
	.until !D[Edx]	; EOL
	cmp [ebx].N,0
	ret
PeIsApiCrc32Fast endp

; +
; ZF if success.
;
PeQueryRoutinesFast proc uses edi Image:PVOID, pList:PVOID
Local Api:APIS
	.if !Image
		invoke PeGetNativeBase
		mov Image,eax
	.endif
	mov edx,pList
	xor eax,eax
	mov Api.pList,edx
	mov ecx,(sizeof(APIS) - APIS.Map)/4
	lea edi,Api.Map
	rep stosd

	mov edi,pList
	mov ecx,esp
	repne scasd
	not ecx
	add ecx,esp
	mov Api.N,ecx
	
	invoke PeEnumExport, Image, offset PeIsApiCrc32Fast, addr Api
	ret
PeQueryRoutinesFast endp

; +
;
PeMapView proc pImage:PVOID, Access:ULONG, ViewBase:PPVOID
Local FileU[MAX_PATH*2 + sizeof(UNICODE_STRING)]:CHAR
Local ObjAttr:OBJECT_ATTRIBUTES
Local File:HANDLE, Section:HANDLE
Local IoStatus:IO_STATUS_BLOCK
Local ViewSize:ULONG
	push NULL
	push sizeof(UNICODE_STRING) + 2*MAX_PATH
	lea eax,FileU
	push eax
	push MemoryMappedFilenameInformation
	push pImage
	push NtCurrentProcess
	%PCALL CRC_NT_QUERY_VIRTUAL_MEMORY, 6
	.if !Eax
		mov ObjAttr.uLength,sizeof(OBJECT_ATTRIBUTES)
		mov ObjAttr.uAttributes,OBJ_CASE_INSENSITIVE
		lea ecx,FileU
		mov ObjAttr.hRootDirectory,eax
		mov ObjAttr.pObjectName,ecx
		mov ObjAttr.pSecurityDescriptor,eax
		mov ObjAttr.pSecurityQualityOfService,eax
		lea eax,IoStatus
		lea ecx,ObjAttr
		lea edx,File
		push 60H
		push 5
		push eax
		push ecx
		push 100020H
		push edx
		%PCALL CRC_NT_OPEN_FILE, 6
		.if !Eax
			lea ecx,Section
			push File
			push 1000000H
			push 10H
			push NULL
			push NULL
			push 0FH
			push ecx
			%PCALL CRC_NT_CREATE_SECTION, 7
			.if !Eax
				mov ViewSize,eax
				lea ecx,ViewSize
				push Access
				push Eax
				push ViewShare
				push Ecx
				push Eax
				push Eax
				push Eax
				push ViewBase
				push NtCurrentProcess
				push Section
				%PCALL CRC_NT_MAP_VIEW_OF_SECTION, 10
				push eax	; STATUS_SUCCESS/STATUS_IMAGE_NOT_AT_BASE
				push Section
				%PCALL CRC_NT_CLOSE, 1
				pop eax
			.endif
			push eax
			push File
			%PCALL CRC_NT_CLOSE, 1
			pop eax
		.endif
	.endif
	ret
PeMapView endp

; +
;
PeRelocate proc uses ebx esi edi Image:PVOID, RE:PVOID, RW:PVOID, RvaBase:ULONG, RvaLimit:ULONG, RelMap:PVOID
	mov eax,Image
	add eax,IMAGE_DOS_HEADER.e_lfanew[eax]
	mov esi,IMAGE_NT_HEADERS.OptionalHeader.DataDirectory.VirtualAddress[eax[IMAGE_DIRECTORY_ENTRY_BASERELOC*sizeof(IMAGE_DATA_DIRECTORY)]]
	mov edi,IMAGE_NT_HEADERS.OptionalHeader.DataDirectory._Size[eax[IMAGE_DIRECTORY_ENTRY_BASERELOC*sizeof(IMAGE_DATA_DIRECTORY)]]
	add esi,Image
	add edi,esi	; Limit
	assume esi:PIMAGE_BASE_RELOCATION
	.repeat
		mov ebx,[esi].SizeOfBlock
		sub ebx,sizeof(IMAGE_BASE_RELOCATION)
		shr ebx,1
		
		mov edx,RE
		sub edx,Image
		sub edx,RvaBase
		mov eax,RelMap
		.repeat
			movzx ecx,W[esi][ebx*2][sizeof(IMAGE_BASE_RELOCATION) - 2]
			.if Ecx
;				IMAGE_REL_BASED_HIGHLOW << 12
				and ecx,PAGE_SIZE - 1
				add ecx,[esi].VirtualAddress	; RVA
				.if (RvaBase <= Ecx) && (RvaLimit > Ecx)
					sub ecx,RvaBase
					bts D[eax],ecx
					add ecx,RW
					add D[ecx],edx
				.endif
			.endif
			dec ebx
		.until Zero?
		add esi,[esi].SizeOfBlock
	.until Esi >= Edi
	xor eax,eax
	ret
PeRelocate endp

; 
;
PeMap proc uses ebx esi edi Section:PHANDLE, RE:PPVOID, FR:PVOID
Local S1ze:ULONG, Rva:RANGE, RW:PVOID, FW:PVOID
Local Relocs:HANDLE
	mov eax,fs:[TEB.Peb]
	mov ebx,PEB.ImageBaseAddress[eax]
	mov edx,ebx
	add edx,IMAGE_DOS_HEADER.e_lfanew[ebx]
	mov ecx,IMAGE_NT_HEADERS.OptionalHeader.SizeOfCode[edx]
	mov edx,IMAGE_NT_HEADERS.OptionalHeader.BaseOfCode[edx]
	mov S1ze,ecx
	mov Rva.Base,edx
	lea esi,[ebx][edx]
	add edx,ecx
	mov Rva.Limit,edx
	
	and RW,0
	and FW,0
	
	mov ecx,S1ze
	shr ecx,3
	invoke MmMap, addr Relocs, Ecx, FR, addr FW
	.if !Eax
		invoke MmMap, Section, S1ze, RE, addr RW
		.if !Eax
			mov ecx,S1ze
			shr ecx,2
			mov edi,RW
			rep movsd
			
			mov eax,RE
			invoke PeRelocate, Ebx, D[Eax], RW, Rva.Base, Rva.Limit, FW
			mov edx,RW
			Call PepUnmap
		.else
			mov edx,FR
			mov edx,D[edx]
			Call PepUnmap
		.endif
		mov edx,Relocs
		Call PepClose
		mov edx,FW
		Call PepUnmap
	.endif
Exit:
	ret
PepUnmap:
	push eax
	push edx
	push NtCurrentProcess
	%PCALL CRC_NT_UNMAP_VIEW_OF_SECTION, 2
	pop eax
	retn
PepClose:
	push eax
	push edx
	%PCALL CRC_NT_CLOSE, 1
	pop eax
	retn
PeMap endp