; +
; ZF if wow, Eax: sel 64.
;
WwGetSeg proc
Local Gdtr[8]:BYTE
	sgdt Gdtr
	xor eax,eax
	movzx ecx,W[Gdtr]	; Limit
	.repeat
		lar edx,eax
		.if Zero?
			and edx,110000011111110B shl 8
			cmp edx,010000011111010B shl 8	; !D, L, P, S, E/R
			je Exit
		.endif
		add eax,8
	.until Eax > Ecx
Exit:
	ret
WwGetSeg endp

RPL_MASK	equ 11B

; +
;
WwCheckGate proc uses ebx
	mov ebx,fs:[DWOW]
	invoke WwGetSeg
	or al,RPL_MASK
	.if (B[Ebx] == 0EAH) && (W[Ebx][5] == Ax)	; EA P32 S16
		lar eax,W [ebx][5]
		.if Zero?
			bt eax,21	; L
			.if Carry?
				invoke MmCrc, Ebx
				push eax
				invoke MmCrc, D[Ebx][1]
				pop edx
				add eax,edx	; 0x444661F6
				jmp Exit
			.endif
		.endif
	.endif
	xor eax,eax
Exit:
	ret
WwCheckGate endp

; +
;
WwReadGate proc
	mov ecx,fs:[0C0H]
	xor eax,eax
	xor edx,edx
	.if Ecx
		cmp B[ecx],0EAH
		cmove eax,D[ecx][1]
		cmove dx,W[ecx][5]
	.endif
	ret
WwReadGate endp

; +
; SYSRET -> ECX -> EIP
; 
WwIsTurbo proc
	%ENVR Eax, Yield
	%RCALL
; ON		wow64cpu.dll	< USD
; OFF	wow64.dll		> USD
	bt ecx,32
	setnc al
	movzx eax,al
	ret
WwIsTurbo endp

; +
;
WwTurboCrc proc
	%ENVR Eax, Yield
	%RCALL
	invoke MmCrc, Ecx
	ret
WwTurboCrc endp

WwGetTurboThunk proto Turbo:PTURBO

	assume ebx:PENV
WwSetupCallback proc
	%DBG "WwSetup.WwSetupCallback"
	invoke WwGetTurboThunk, addr [Ebx].Wow.Turbo
	%DBG "WwSetup.WwGetTurboThunk 0x%X", Eax
	%DBG "WwSetup.TURBO Id: 0x%X, Thunk: 0x%p, Return: 0x%p, Service: 0x%p, Dispatch: 0x%p", 
		[Ebx].Wow.Turbo.Dispatch, 
		[Ebx].Wow.Turbo.Service,
		[Ebx].Wow.Turbo.Return,
		[Ebx].Wow.Turbo.Thunk,
		[Ebx].Wow.Turbo.Id
	ret
WwSetupCallback endp

; +
; OUT:
;	@TurboThunkDispatch
;
Ww64GetTurboThunk proc C
	DB 4CH, 89H, 0F8H	; mov rax,r15
	%RETFN
Ww64GetTurboThunk endp

comment '
 TurboThunkDispatch:
	@TurboDispatchJumpAddressEnd
	@Thunk0Arg

 Thunk0Arg:
	call CpupSyscallStub
	'
; +
;
;
WwGetTurboThunk proc uses ebx esi edi Turbo:PTURBO
Local Mm:MEMORY_BASIC_INFORMATION
	%CALL64 Ww64GetTurboThunk
	%DBG "WwGetTurboThunk.Ww64GetTurboThunk", Eax
	mov esi,CRC_WOW64CPU
	mov ebx,eax
	invoke MmCrc, Eax
	%DBG "WwGetTurboThunk.CRC_WOW64CPU", Eax
	.if Eax == Esi
		mov edi,24
	@@:
		invoke MmCrc, D[Ebx][Edi*8][-8]
		.if (Eax == Esi) && !D[Ebx][Edi*8][-8][4]
			dec edi
			jnz @b
			%DBG "WwGetTurboThunk.TURBOTHUNK OK", Eax

			mov eax,D[ebx][8]	; Thunk0Arg
			.if B[Eax] == 0E8H
				; @Thunk -> .data[sizeof(data)][-8]
				lea eax,Mm
				push NULL
				push sizeof(MEMORY_BASIC_INFORMATION)
				push eax
				push MemoryBasicInformation
				push ebx
				push NtCurrentProcess
				%PCALL CRC_NT_QUERY_VIRTUAL_MEMORY, 6
				mov esi,Mm.AllocationBase
				.if !Eax
				Scan:
					mov eax,Mm.BaseAddress
					add eax,Mm.RegionSize
					
					bt Mm.Protect,2	; PAGE_READWRITE			
					.if Carry?
						sub eax,8
						.if !D[Eax]
							mov esi,Turbo
							assume esi:PTURBO
							
							mov ecx,D[ebx][8]	; Thunk0Arg
							add ecx,5
							
							mov edx,eax
							sub edx,ebx
							shl edx,13
							
							mov [esi].Thunk,eax		; @V:THUNK64
							mov [esi].Return,ecx
							mov [esi].Id,edx		; ID << 16
							mov ecx,D[ebx][0]		; TurboDispatchJumpAddressEnd
							mov [esi].Dispatch,ebx	; TurboThunkDispatch
							mov [esi].Service,ecx	
							jmp Exit
						.endif
					.endif
					
					lea ecx,Mm
					push NULL
					push sizeof(MEMORY_BASIC_INFORMATION)
					push ecx
					push MemoryBasicInformation
					push eax
					push NtCurrentProcess
					%PCALL CRC_NT_QUERY_VIRTUAL_MEMORY, 6
					.if !Eax
						cmp Mm.AllocationBase,esi
						je Scan
					.endif
				.endif
			.endif
		.endif
	.endif
	xor eax,eax
Exit:
	ret
WwGetTurboThunk endp

; +
; OUT:
;	RANGE(wow64cpu.dll)
;
WwGetImage proc uses esi Range:PRANGE
Local Mm:MEMORY_BASIC_INFORMATION
	and Mm.BaseAddress,0
	.repeat
		lea ecx,Mm
		push NULL
		push sizeof(MEMORY_BASIC_INFORMATION)
		push ecx
		push MemoryBasicInformation
		push Mm.BaseAddress
		push NtCurrentProcess
		%PCALL CRC_NT_QUERY_VIRTUAL_MEMORY, 6
		test eax,eax
		jnz Exit
		.if Mm._Type == MEM_IMAGE
			mov esi,Mm.AllocationBase
			.repeat
				mov eax,Mm.RegionSize
				lea ecx,Mm
				add Mm.BaseAddress,eax
				push NULL
				push sizeof(MEMORY_BASIC_INFORMATION)
				push ecx
				push MemoryBasicInformation
				push Mm.BaseAddress
				push NtCurrentProcess
				%PCALL CRC_NT_QUERY_VIRTUAL_MEMORY, 6
				test eax,eax
				jnz Exit
			.until Mm.AllocationBase != Esi
			invoke MmCrc, Esi
			.if Eax == CRC_WOW64CPU
				mov ecx,Range
				mov edx,Mm.BaseAddress
				xor eax,eax
				mov RANGE.Base[ecx],esi
				mov RANGE.Limit[ecx],edx
				jmp Exit
			.endif
		.endif
		mov eax,Mm.RegionSize
		add Mm.BaseAddress,eax
	.until Mm.BaseAddress >= 7FFE0000H
	mov eax,STATUS_DLL_NOT_FOUND
Exit:
	ret
WwGetImage endp

; +
;
WwGetGate proc uses edi Range:PRANGE
	mov edx,Range
	assume edx:PRANGE
	mov ecx,[edx].Limit
	mov edi,[edx].Base
	sub ecx,edi
Scan:
	mov eax,0EAH	; JMP FAR P32:S16
	repne scasb
	.if Zero?
		cmp W PCS.Ssel[edi],(KGDT64_R3_CODE or RPL_MASK)
		jne Scan
		mov eax,PCS.Sptr[edi]
		.if ([Edx].Base < Eax) && ([Edx].Limit > Eax)
			lea edx,[edi][-1]
		Exit:
			ret
		.endif
	.endif
	xor eax,eax
	jmp Exit
WwGetGate endp

PeMapView proto pImage:PVOID, Access:ULONG, ViewBase:PPVOID

; +
;
; OUT:
;	pGate	@wow64!CpupReturnFromSimulatedCode
;
WwQueryGate proc pGate:PPVOID
Local Wow:RANGE
Local Raw:PVOID
	invoke WwGetImage, addr Wow
	%DBG "WwQueryGate.WwGetImage 0x%X", Eax
	.if !Eax
		%DBG "WwQueryGate.WOW 0x%p 0x%p", Wow.Limit, Wow.Base
		invoke WwGetGate, addr Wow
		%DBG "WwQueryGate.WwGetGate 0x%p", Eax
		.if !Eax
			mov Raw,eax
			invoke PeMapView, Wow.Base, PAGE_READONLY, addr Raw
			%DBG "WwQueryGate.PeMapView 0x%X", Eax
			test eax,eax
			jl Exit
			invoke WwGetGate, addr Wow
			%DBG "WwQueryGate.WwGetGate 0x%X", Eax
			.if !Eax
				push STATUS_ENTRYPOINT_NOT_FOUND
			.else
				push STATUS_BAD_DLL_ENTRYPOINT
			.endif
			push Raw
			push NtCurrentProcess
			%PCALL CRC_NT_UNMAP_VIEW_OF_SECTION, 2
			pop eax
		.else
			mov ecx,pGate
			mov D[ecx],eax
			xor eax,eax
		.endif
	.endif
Exit:
	ret
WwQueryGate endp

; +
;
WwSetup proc uses ebx esi
	%ENVP Ebx
	invoke WwQueryGate, addr [Ebx].Wow.Ps.Sptr
	%DBG "WwSetup.WwQueryGate 0x%X", Eax
	.if !Eax
		mov [ebx].Wow.Ps.Ssel,(KGDT64_R3_CODE or RPL_MASK)
		invoke WwIsTurbo
		%DBG "WwSetup.WwIsTurbo 0x%X", Eax
		.if !Carry?
			invoke WwTurboCrc
			mov esi,eax
			%DBG "WwSetup.WwTurboCrc 0x%X", Eax
			invoke Crc32D, CRC32_BASE, Eax
			.if Eax == 0D2391E8FH
				add esi,offset WwSetupCallback - CRC_WOW64CPU
				Call Esi
				jmp Exit
			.endif
		.endif
	.endif
	xor eax,eax
Exit:
	ret
WwSetup endp							